#include <sys/time.h>

Get_time(struct timespec *time) {
    struct timeval *now;

    now =(struct timeval*)Malloc(sizeof(struct timeval));
    if (gettimeofday(now,NULL) != 0) {
        free(now);
	return -1;
    }
    time->tv_sec=now->tv_sec;
    time->tv_nsec=now->tv_usec*1000;
    free(now);
    return 0;
}

int update_timeout(struct timespec *timeout, struct timespec *begin) {
    struct timespec *now;
    time_t sec=0;

    now =(struct timespec*)Malloc(sizeof(struct timespec));
    if (Get_time(now))
	return -1;
    if ((now->tv_sec < begin->tv_sec) || ((now->tv_sec == begin->tv_sec) && (now->tv_nsec < begin->tv_nsec))) {
	err_msg("New time is less than old time");
	free(begin);
	begin=now;
	return update_timeout(timeout,begin);
    } 
    timeout->tv_sec-=now->tv_sec-begin->tv_sec;
    timeout->tv_nsec-=now->tv_nsec-begin->tv_nsec;
    if (timeout->tv_nsec <0) {
	timeout->tv_sec--;
	timeout->tv_nsec+=1000*1000*1000;
    }
    free(now);
    if (timeout->tv_sec < 0 ||((timeout->tv_sec==0) && (timeout->tv_nsec==0)))
	return 0;
    else
	return 1;
}